<template>
    <div class="dashboard">
        <div class="flex-container">
            <div class="flex-item ">
                <img class="logotipo" :src="ruta + '/img/Logos/Pantalla dentro de DigiDocs.png'">
            </div>  
            <div class="flex-item filtro" id="custom-search-input">
                <div class="input-group col-md-12">
                    <input 
                        type="text" 
                        class="search-query form-control" 
                        v-model="search" 
                        placeholder="Buscar en Digidocs" 
                    />
                    <span class="input-group-btn">
                        <button 
                            class="btn btn-danger" 
                            type="button"
                        >
                            <span>
                                <img :src="ruta + '/img/iconos/Buscar_Barra_de_busqueda.png'">
                            </span>
                        </button>
                    </span>
                </div>
            </div>
            <div class="flex-item usuario">
                <h5><strong>{{ usuario }}</strong></h5>
            </div>           
        </div>
        <div class=" overflow-auto">
        <div class="general">
            <div class="flex-menus">
                <div class="column-1">
                    <div class="btn-group reduccion">
                        <button 
                            type="button" 
                            class="btn-nuevo dropdown-toggle" 
                            data-toggle="dropdown" 
                            aria-haspopup="true" 
                            aria-expanded="false"
                        >
                            <i class="fas fa-plus"></i> Nuevo
                        </button>

                        <div class="dropdown-menu" >
                            <button 
                                class="dropdown-item" 
                                type="button"  
                                @click="showModalCrearCarpeta()" 
                            >
                                <i class="fas fa-folder-plus"></i> Crear Carpeta
                            </button>
                            <br>
                            <button 
                                class="dropdown-item"  
                                type="button" 
                                @click="showModalCrearArchivos()"
                            >
                                <img :src="ruta + '/img/iconos/Subir_archivo_del_boton_principal.png'"> 
                                Subir Archivo(s)
                            </button>
                        </div>
                    </div>

                    <ModalRegistrarArchivos 
                        ref="modalArchivosRef"
                        :carpetas="carpetas"
                        @archivo-registrado="postArchivoRegistrado()"
                    />
                    <ModalRegistrarCarpeta 
                        ref="modalCarpetaRef" 
                        @carpeta-registrada="postCarpetaRegistrada()"
                    />

                </div>
                <div class="column-2" >
                    <ol class="breadcrumb float-left" style="width:100%;" >
                        <li class="breadcrumb-item">
                            <a href="#" @click="getCarpetas()">Inicio</a>
                        </li>
                        <li class="breadcrumb-item active">{{ carpetaActual }}</li>
                    </ol>
                </div>
            </div>
            <div class="flex-contenido">
                <div class="column-carpetas reduccion">
                    <table class="table table-bordered t-carpeta ">
                        <thead class="thead">                  
                            <tr class="tr">
                                <th class="th">Carpetas</th>
                            </tr>
                        </thead>
                        <tbody class="tbody">
                            <tr 
                                v-for="(carpeta, index) in carpetas" 
                                :key="index" 
                                class="tr"
                            >
                                <td class="td">
                                    <button 
                                        class='btn item-wrapper__item' 
                                        @contextmenu.prevent="handleClick($event, carpeta)"
                                        @click="selectedCarpeta(carpeta)"
                                    >
                                        <img :src="ruta + '/img/iconos/Carpeta.png'"> {{ carpeta.nombre }}
                                    </button>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    <br>
                    <button 
                        id="btn-danger" 
                        class="btn btn-danger" 
                        type="submit" 
                        @click="logout()"
                    >
                        <img :src="ruta + '/img/iconos/Cerrar_sesion.png'">
                        Salir
                    </button>
                </div>
                <vue-simple-context-menu
                  :elementId="'myUniqueId'"
                  :options="options"
                  :ref="'vueSimpleContextMenu'"
                  @option-clicked="optionClicked"
                />
                <modalEditarCarpeta :id="id_carpeta" :ruta="ruta" :nombre_carpeta="nombre_carpeta" @carpeta-actualizada="postCarpetaActualizada()"/>
                <TablaVerArchivos 
                    v-show="tablaVerArchivosEsVisible"
                    :archivos="archivos"
                    :ruta="ruta"
                    :currentArchivo="currentArchivo"
                    @ocultar-tabla="tablaVerArchivosEsVisible = false"
                />

                <div class="column-archivos table-wrapper-scroll-y my-custom-scrollbar" v-show="!tablaVerArchivosEsVisible">
                    <table class="table table-bordered "  > 
                        <thead id="head">                 
                            <tr>
                                <th @click="orderBy('nombre')" >Nombre Archivo</th>
                                <th style="width:10%">Opciones</th>
                                <th @click="orderBy('created_at')">Fecha</th>
                                <th @click="orderBy('tipo')">Tipo Archivo</th>
                                <th @click="orderBy('peso')">Tamaño</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr 
                                v-for="(archivo, index) in filteredFiles(archivos)" 
                                :key="index"
                            >
                                <td >
                                    <img :src="ruta + '/img/iconos/Documento.png'"> 
                                    {{ archivo.nombre }}
                                </td>
                                <td id="th-body">
                                    <a 
                                        @click="descargarArchivo(archivo.id_archivo)" 
                                        data-toggle="tooltip" 
                                        title="Descargar"
                                    >
                                        <img :src="ruta + '/img/iconos/Descargar.png'">
                                    </a>
                                    <a @click.prevent="eliminarArchivo(archivo.id_archivo)"
                                        data-toggle="tooltip" 
                                        title="Eliminar"
                                    >
                                        <img :src="ruta + '/img/iconos/Papelera.png'">
                                    </a>
                                    <a @click="verArchivos(archivo)" v-if="archivo.tipo == 'application/pdf'"
                                        data-toggle="tooltip" 
                                        title="Ver"
                                    >
                                        <img :src="ruta + '/img/iconos/Ver.png'">
                                    </a>
                                    <a @click="verArchivos(archivo)" v-else-if="archivo.tipo == 'image/jpeg'"
                                        data-toggle="tooltip" 
                                        title="Ver"
                                    >
                                        <img :src="ruta + '/img/iconos/Ver.png'">
                                    </a>
                                    <a @click="verArchivos(archivo)" v-else-if="archivo.tipo == 'image/png'"
                                        data-toggle="tooltip" 
                                        title="Ver"
                                    >
                                        <img :src="ruta + '/img/iconos/Ver.png'">
                                    </a>
                                </td>
                                <td id="th-body1">
                                    {{ archivo.created_at }}
                                </td>
                                <td id="th-body2">
                                    {{ getTipo(archivo.tipo) }}
                                </td>
                                <td>
                                    {{ getPeso(archivo.peso) }} 
                                </td> 
                            </tr>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
        </div>
        <footer class="main-footer footer-dashboard">
            <h6>© Copyright 2021 | DIGIDOCS | Solumáticas GRM | Todos los derechos reservados |</h6>
        </footer>
    </div>
</template>

<script>

import modalEditarCarpeta from './modalEditarCarpeta.vue';
import ModalRegistrarArchivos from './crearArchivos.vue';
import ModalRegistrarCarpeta  from './crearCarpeta.vue';
import TablaVerArchivos       from './tablaVerArchivos.vue';

export default {

    props: {
        ruta: {
            type: String
        }
    },

    components: {
        ModalRegistrarArchivos, 
        ModalRegistrarCarpeta, 
        TablaVerArchivos,
        modalEditarCarpeta
    },
    
    data: () => {
        return {
            carpetas: [],
            archivos: [],
            search: "",
            usuario: localStorage.getItem('usuario'),
            carpetaActual: "",
            idCarpetaActual: 0,
            tablaVerArchivosEsVisible: false,
            currentArchivo: {},
            options: [
                {
                    name: 'Editar'
                }
            ],
            id_carpeta: 0,
            nombre_carpeta: ''
        }
    },
    
    async created() {
        await this.getCarpetas();        
    },

    methods: {
        filteredFiles: function() {
            return this.archivos.filter((data) => {
                return data.nombre.match(this.search);
            });
        },
        async getCarpetas() {

            const idUsuario = localStorage.getItem('idUsuario');

            const response = await axios.get(
                this.ruta + `/api/carpetas?filter[idUsuario]=${idUsuario}`
            );

            this.carpetas = response.data['data'];
            this.archivos = this.carpetas.map(carpeta => carpeta.archivos).flat();
        }, 

        selectedCarpeta(carpetaActual) {
            this.carpetaActual = carpetaActual.nombre;

            this.archivos = this.carpetas.flatMap(carpeta => 
                (carpeta.id_carpeta == carpetaActual.id_carpeta)
                ? carpeta.archivos 
                : []
            );
        },

        handleClick (event, item) {
            this.$refs.vueSimpleContextMenu.showMenu(event, item)
        },

        async optionClicked (event) {
            var data = {
                id:event.item.id_carpeta
            }
            var response = await axios.post(this.ruta + '/api/carpeta-by-id', data);
            var dataRes = response.data.carpeta;
            this.id_carpeta = dataRes.id_carpeta;
            this.nombre_carpeta = dataRes.nombre;
            this.$root.$emit("bv::toggle::modal", "editarCarpeta");
            await this.getCarpetas();
        },

        orderBy(key) {
            this.archivos = this.archivos.sort(function(a, b) {
                return a[key].localeCompare(b[key], 'en', { numeric: true })
            });
        },

        async eliminarArchivo(idArchivo) {

            const response = await axios.delete(this.ruta + `/api/archivos/${idArchivo}`);

            this.$utils.showSuccess(response.data['message']);
            await this.getCarpetas();
        },

        verArchivos(archivo) {

            this.currentArchivo = archivo;
            this.tablaVerArchivosEsVisible = true;
        },

        async descargarArchivo(idArchivo) {

            const url = `/api/archivos/download/${idArchivo}`;

            const a = document.createElement('a');
            a.href = url;
            a.click();
        },

        showModalCrearArchivos() {

            let element = this.$refs.modalArchivosRef.$el;
            $(element).modal('show')
        },

        showModalCrearCarpeta() {

            let elemento = this.$refs.modalCarpetaRef.$el;
            $(elemento).modal('show')
        },

        hideModalCrearArchivos() {

            let element = this.$refs.modalArchivosRef.$el;
            $(element).modal('hide')
        },

        hideModalCrearCarpeta() {

            let elemento = this.$refs.modalCarpetaRef.$el;
            $(elemento).modal('hide')
        },

        async postCarpetaActualizada() {

            await this.getCarpetas();
        },

        async postCarpetaRegistrada() {

            this.hideModalCrearCarpeta();
            await this.getCarpetas();
        },

        async postArchivoRegistrado() {

            this.hideModalCrearArchivos();
            await this.getCarpetas();
        },

        getTipo(tipoCode) {

            switch (tipoCode) {
                case "image/jpeg":
                    return "JPG";
                    break;
                case "image/png":
                    return "PNG";
                    break;
                case "application/pdf":
                    return "PDF";
                    break;
                case "application/vnd.openxmlformats-officedocument.wordprocessingml.document":
                    return "DOCX"
                    break;
                case "application/vnd.openxmlformats-officedocument.presentationml.presentation":
                    return "PPTX"
                    break;
                case "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet":
                    return "XLSX"
                    break;
                default:
                    return tipoCode;
            }
        },
        
        getPeso(pesoCode) {

            switch (pesoCode) {
                case pesoCode :
                    if(pesoCode < 1024) {
                        return pesoCode+" B"
                    } else if (pesoCode >= 1024) {
                        pesoCode = Math.round(pesoCode / 1024);
                        return pesoCode+" KB"
                    } else if (pesoCode >= 1048576) {
                        pesoCode = Math.round(pesoCode / 1048576);
                        return pesoCode+" MB"
                    } else if (pesoCode >= 1073741824) {
                        pesoCode = Math.round(pesoCode / 1073741824);
                        return pesoCode+" GB"
                    } else if (pesoCode >= 1099511627776) {
                        pesoCode = Math.round(pesoCode / 1099511627776);
                        return pesoCode+" TB"
                    }
                break;
                default:
                    return pesoCode;
            }

        },

        logout() {
            localStorage.clear();
            this.$router.push({ name: 'login' });
        }
    }
}
</script>
<style>
.my-custom-scrollbar {
    position: relative;
    height: 435px !important;
    overflow: auto;
}
.table-wrapper-scroll-y {
    display: block;
}
#head th {
    position: sticky; 
    top: 0;
    z-index: 1;
    background:rgb(255, 255, 255);
}

</style>